Skip to content

proof(SafeCryptoAccel): add Proofs.idr — 35 RFC/NIST anchors, 0 OWED - #35

Merged
hyperpolymath merged 4 commits into
mainfrom
proof-debt/standards-132-safecryptoaccel
May 20, 2026
Merged

hyperpolymath merged 4 commits into
mainfrom
proof-debt/standards-132-safecryptoaccel

Conversation

@hyperpolymath

Copy link
Copy Markdown
Owner

35 machine-checked theorems anchoring FIPS-197/RFC-8439/RFC-8032/RFC-7748 key+IV lengths, categorise exhaustiveness, quantum-safety classification, and validateKeySpec correctness. Zero OWED. Refs metadatastician/standards#124, metadatastician/standards#132.

…132)

`Proven.SafeCryptoAccel` claimed "misconfigured crypto parameters are
caught at validation time rather than causing hardware faults" but
shipped no `Proofs.idr` — one of the ~30 named gaps under
standards#132.

This commit lands `src/Proven/SafeCryptoAccel/Proofs.idr` with 35
machine-checked theorems and ZERO OWED postulates.

DISCHARGED:
  * Key-length anchors (9): AES-128/256 = 16/32B (FIPS 197),
    ChaCha20 = 32B (RFC 8439), SHA-256/512 = 0B (hash),
    Ed25519 = 32B (RFC 8032), X25519 = 32B (RFC 7748),
    RSA-2048/4096 = 256/512B.
  * IV/nonce anchors (9): AES = 16B IV, ChaCha20 = 12B nonce,
    every other algorithm = Nothing.
  * `categorise` exhaustiveness (9): every CryptoOp lands in
    Symmetric/Hash/Asymmetric as declared.
  * Quantum-safety classification (9): exactly AES-256 + SHA-512
    are quantum-safe; the other 7 are explicitly NOT.
  * `validateKeySpec` correctness (5): canonical KeySpec for each
    Symmetric/Asymmetric family passes; wrong key length rejected.

Refs metadatastician/standards#124, metadatastician/standards#132.

Co-Authored-By: Claude Opus 4.7 (1M context) <noreply@anthropic.com>
@@ -0,0 +1,243 @@
-- SPDX-License-Identifier: PMPL-1.0-or-later
@github-actions

Copy link
Copy Markdown

🔍 Hypatia Security Scan

Findings: 297 issues detected

Severity Count
🔴 Critical 182
🟠 High 18
🟡 Medium 97

⚠️ Action Required: Critical security issues found!

View findings
[
  {
    "reason": "Issue in quality.yml",
    "type": "missing_workflow",
    "file": "quality.yml",
    "action": "create",
    "rule_module": "workflow_audit",
    "severity": "high"
  },
  {
    "reason": "Issue in security-policy.yml",
    "type": "missing_workflow",
    "file": "security-policy.yml",
    "action": "create",
    "rule_module": "workflow_audit",
    "severity": "medium"
  },
  {
    "reason": "Action hyperpolymath/standards/.github/workflows/governance-reusable.yml@main needs attention",
    "type": "unpinned_action",
    "file": "governance.yml",
    "action": "pin_sha",
    "rule_module": "workflow_audit",
    "severity": "high"
  },
  {
    "reason": "Python file detected -- banned language",
    "type": "banned_language_file",
    "file": "/home/runner/work/proven/proven/bindings/python/benchmarks/test_benchmarks.py",
    "action": "flag",
    "rule_module": "cicd_rules",
    "severity": "critical"
  },
  {
    "reason": "Python file detected -- banned language",
    "type": "banned_language_file",
    "file": "/home/runner/work/proven/proven/bindings/python/proven/safe_email.py",
    "action": "flag",
    "rule_module": "cicd_rules",
    "severity": "critical"
  },
  {
    "reason": "Python file detected -- banned language",
    "type": "banned_language_file",
    "file": "/home/runner/work/proven/proven/bindings/python/proven/safe_retry.py",
    "action": "flag",
    "rule_module": "cicd_rules",
    "severity": "critical"
  },
  {
    "reason": "Python file detected -- banned language",
    "type": "banned_language_file",
    "file": "/home/runner/work/proven/proven/bindings/python/proven/safe_math.py",
    "action": "flag",
    "rule_module": "cicd_rules",
    "severity": "critical"
  },
  {
    "reason": "Python file detected -- banned language",
    "type": "banned_language_file",
    "file": "/home/runner/work/proven/proven/bindings/python/proven/safe_uuid.py",
    "action": "flag",
    "rule_module": "cicd_rules",
    "severity": "critical"
  },
  {
    "reason": "Python file detected -- banned language",
    "type": "banned_language_file",
    "file": "/home/runner/work/proven/proven/bindings/python/proven/safe_header.py",
    "action": "flag",
    "rule_module": "cicd_rules",
    "severity": "critical"
  },
  {
    "reason": "Python file detected -- banned language",
    "type": "banned_language_file",
    "file": "/home/runner/work/proven/proven/bindings/python/proven/safe_content_type.py",
    "action": "flag",
    "rule_module": "cicd_rules",
    "severity": "critical"
  }
]

Powered by Hypatia Neurosymbolic CI/CD Intelligence

@hyperpolymath
hyperpolymath merged commit 2da0b2b into main May 20, 2026
12 of 20 checks passed
@hyperpolymath
hyperpolymath deleted the proof-debt/standards-132-safecryptoaccel branch May 20, 2026 12:05
@sonarqubecloud

Copy link
Copy Markdown

@github-actions

Copy link
Copy Markdown

🔍 Hypatia Security Scan

Findings: 301 issues detected

Severity Count
🔴 Critical 186
🟠 High 18
🟡 Medium 97

⚠️ Action Required: Critical security issues found!

View findings
[
  {
    "reason": "Issue in quality.yml",
    "type": "missing_workflow",
    "file": "quality.yml",
    "action": "create",
    "rule_module": "workflow_audit",
    "severity": "high"
  },
  {
    "reason": "Issue in security-policy.yml",
    "type": "missing_workflow",
    "file": "security-policy.yml",
    "action": "create",
    "rule_module": "workflow_audit",
    "severity": "medium"
  },
  {
    "reason": "Action hyperpolymath/standards/.github/workflows/governance-reusable.yml@main needs attention",
    "type": "unpinned_action",
    "file": "governance.yml",
    "action": "pin_sha",
    "rule_module": "workflow_audit",
    "severity": "high"
  },
  {
    "reason": "Python file detected -- banned language",
    "type": "banned_language_file",
    "file": "/home/runner/work/proven/proven/bindings/python/benchmarks/test_benchmarks.py",
    "action": "flag",
    "rule_module": "cicd_rules",
    "severity": "critical"
  },
  {
    "reason": "Python file detected -- banned language",
    "type": "banned_language_file",
    "file": "/home/runner/work/proven/proven/bindings/python/proven/safe_email.py",
    "action": "flag",
    "rule_module": "cicd_rules",
    "severity": "critical"
  },
  {
    "reason": "Python file detected -- banned language",
    "type": "banned_language_file",
    "file": "/home/runner/work/proven/proven/bindings/python/proven/safe_retry.py",
    "action": "flag",
    "rule_module": "cicd_rules",
    "severity": "critical"
  },
  {
    "reason": "Python file detected -- banned language",
    "type": "banned_language_file",
    "file": "/home/runner/work/proven/proven/bindings/python/proven/safe_math.py",
    "action": "flag",
    "rule_module": "cicd_rules",
    "severity": "critical"
  },
  {
    "reason": "Python file detected -- banned language",
    "type": "banned_language_file",
    "file": "/home/runner/work/proven/proven/bindings/python/proven/safe_uuid.py",
    "action": "flag",
    "rule_module": "cicd_rules",
    "severity": "critical"
  },
  {
    "reason": "Python file detected -- banned language",
    "type": "banned_language_file",
    "file": "/home/runner/work/proven/proven/bindings/python/proven/safe_header.py",
    "action": "flag",
    "rule_module": "cicd_rules",
    "severity": "critical"
  },
  {
    "reason": "Python file detected -- banned language",
    "type": "banned_language_file",
    "file": "/home/runner/work/proven/proven/bindings/python/proven/safe_content_type.py",
    "action": "flag",
    "rule_module": "cicd_rules",
    "severity": "critical"
  }
]

Powered by Hypatia Neurosymbolic CI/CD Intelligence

Sign up for free to join this conversation on GitHub. Already have an account? Sign in to comment

Labels

None yet

Projects

None yet

Development

Successfully merging this pull request may close these issues.

2 participants